var objTxtbgfixerBrowser = {

	onload: function (ndTarget)
	{
		if ( ! gPrefService.prefHasUserValue('txtbgfixer.enabled') )
			gPrefService.setBoolPref( 'txtbgfixer.enabled', true );

		if ( ! gPrefService.getBoolPref('txtbgfixer.enabled') ||
			! gPrefService.getBoolPref('browser.display.use_document_colors') ) return;

		var ndDocument = ndTarget.originalTarget;
		var ndBody = ndDocument.getElementsByTagName("body")[0]; if (ndBody==null) return;
		var sBgcolor = ndBody.getAttribute("bgcolor");
		var sTxtcolor = ndBody.getAttribute("text");

		if ( sBgcolor && ! sTxtcolor ) {
			if ( sBgcolor != "#000000" ) ndBody.setAttribute("text", "#000000");
		}
		else if ( ! sBgcolor && sTxtcolor ) {
			if (sTxtcolor != "#FFFFFF" ) ndBody.setAttribute("bgcolor", "#FFFFFF");
		}
		else if ( ! sBgcolor && !sTxtcolor ) {
			if ( ndDocument.getElementsByTagName("div").length > 0 ) {
				ndBody.setAttribute("text", "#000000");
				ndBody.setAttribute("bgcolor", "#FFFFFF");
			}
			else if ( ndTD = ndDocument.getElementsByTagName("td") ) {
				for ( i = 0; i < ndTD.length; ++i ) {
					if ( ndTD[i].getAttribute("bgcolor") ) {
						ndBody.setAttribute("text", "#000000");
						ndBody.setAttribute("bgcolor", "#FFFFFF");
						break;
					}
				}
			}
		}

		if ( ndDocument.getElementsByTagName("form").length > 0 ) {
			this.fixElementStyle (ndDocument, "input");
			this.fixElementStyle (ndDocument, "textarea");
			this.fixElementStyle (ndDocument, "select");
			this.fixElementStyle (ndDocument, "option");
		}

		if ( ndDocument.links.length > 0 && ndDocument.styleSheets.length > 0 ) {
			sLinkcolor = ndDocument.defaultView.getComputedStyle(ndDocument.links[0],'').getPropertyValue("color");

			for ( i = 0; i < ndDocument.styleSheets[0].cssRules.length; ++i ) {
				if (ndDocument.styleSheets[0].cssRules[i].selectorText.indexOf("a:visited") != -1 ) {
					if ( (sVlinkcolor=ndDocument.styleSheets[0].cssRules[i].style.color) != "" ) {
						if ( sLinkcolor == sVlinkcolor ) {
							aVlinkcolorRGB = this.rgbToArray(sVlinkcolor);
							for ( j = 0; j < 3; j++ ) {
								aVlinkcolorRGB[j] -= 51;
								if (aVlinkcolorRGB[j] < 0) aVlinkcolorRGB[j] = 0;
							}
							ndDocument.styleSheets[0].cssRules[i].style.color = this.arrayToRgb(aVlinkcolorRGB);
							break;
						}
					}
				}
			}
		}

	},

	fixElementStyle: function ( ndDocument, tagname ) {
		if ( ndElements = ndDocument.getElementsByTagName(tagname) ) {
			for ( i = 0; i < ndElements.length; ++i ) {
				sElementColor = ndDocument.defaultView.getComputedStyle(ndElements[i],'').getPropertyValue("color");
				sElementBgcolor = ndDocument.defaultView.getComputedStyle(ndElements[i],'').getPropertyValue("background");
				if ( sElementBgcolor=="" )
					sElementBgcolor = ndDocument.defaultView.getComputedStyle(ndElements[i],'').getPropertyValue("background-color");

				aElementColorRGB = this.rgbToArray(sElementColor);
				aElementBgcolorRGB = this.rgbToArray(sElementBgcolor);
				
				colorDiff = 0;
				if ( aElementColorRGB && aElementBgcolorRGB )					
					for ( j = 0; j < 3; j++ )
						colorDiff += Math.abs(aElementColorRGB[j] - aElementBgcolorRGB[j]);

				if ( colorDiff < 51 )
						ndElements[i].setAttribute("style", ndElements[i].getAttribute("style") +
								"; background: #CCCCCC; color: #000000;");
			}
		}
	},

	rgbToArray: function ( sRGB ) {
		sRGB = sRGB.replace("rgb(","").replace(")","");
		retval = sRGB.split(",");
		if ( retval.length == 3 ) return retval; else return null;
	},

	arrayToRgb: function ( aRGB ) {
		return "rgb(" + aRGB[0] + ", " + aRGB[1] + ", " + aRGB[2] + ")";
	},


	toggle: function()
	{
		if ( gPrefService.getBoolPref('txtbgfixer.enabled') ) {
			gPrefService.setBoolPref( 'txtbgfixer.enabled', false );
			gPrefService.setBoolPref( 'browser.display.use_document_colors', true );
			window._content.document.location.reload();
			this.setstatustxt( "Txt-Bgcolor Fixer off" );
		}
		else if ( gPrefService.getBoolPref('browser.display.use_document_colors') ) {
			gPrefService.setBoolPref( 'txtbgfixer.enabled', false );
			gPrefService.setBoolPref( 'browser.display.use_document_colors', false );
			window._content.document.location.reload();
			this.setstatustxt( "Txt-Bgcolor Fixer on" );
		}
		else {
			gPrefService.setBoolPref( 'txtbgfixer.enabled', true );
			gPrefService.setBoolPref( 'browser.display.use_document_colors', true );
			window._content.document.location.reload();
			this.setstatustxt( "Txt-Bgcolor Fixer forcing user-defined colors" );
		}
	},


	setstatustxt: function (msg)
	{
		document.getElementById("statusbar-display").label = msg;
	}


}

function txtbgfixerLoadWindow (e) {
	objTxtbgfixerBrowser.onload (e);
}

window.addEventListener ("load", txtbgfixerLoadWindow, true);
